/* As a global note, I have removed the context member everywhere,
   because it is now included in the command header.  The process ID
   has been changed to a 64-bit value.  Otherwise, these structures
   are the same as were previously contained in the command union. */

typedef unsigned __int64	ra_uint64_t;

struct {
	ra_string_t user;
	ra_string_t passwd;
}dce_authenticate_data;							/* AUTHENTICATE */

struct {
	ra_string_t key;
}dce_authenticate_successful_data;				/* AUTHENTICATION_SUCCESSFUL */

struct {
	ra_uint_t ticket;
}dce_authenticate_failed_data;					/* AUTHENTICATION_FAILED */


struct {
    ra_uint_t flag;
    ra_uint_t securePort;
}dce_serverSecurityRequirements_data;            /* RA_SERVER_SECURITY_REQUIREMENTS */

struct {
	ra_uint_t   consoleIP;
	ra_uint_t   consolePort;
	ra_string_t executable;
	ra_string_t arguments;
	ra_string_t location;
	ra_array_t  environment;
	ra_array_t  agents;
}dce_launch_process_data;						/* LAUNCH_PROCESS*/

struct {
	ra_uint64_t processId;
	ra_string_t processUUID;
	ra_string_t executable;
	ra_string_t arguments;
	ra_array_t environment;
}dce_process_launched_data;						/* PROCESS_LAUNCHED */

/* In the new protocol, QUERY_PROCESS_LIST won't need any data */
/* struct {
}dce_query_process_list_data; */					/* QUERY_PROCESS_LIST */

struct {
	ra_array_t processes;
}dce_registered_process_list_data;				/* REGISTERED_PROCESS_LIST */

struct {
	ra_uint64_t processId;
}dce_query_agent_list_data,						/* QUERY_AGENT_LIST */
 dce_kill_process_data,							/* KILL_PROCESS */
 dce_process_exited_data;						/* PROCESS_EXITED */

struct {
	ra_uint64_t processId;
	ra_string_t executable;
	ra_array_t  agents;
}dce_registered_agents_list_data;				/* REGISTERED_AGENTS_LIST */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
}dce_register_agent_notification_data,			/* REGISTER_AGENT_NOTIFICATION */
 dce_query_agent_details_data;					/* QUERY_AGENT_DETAILS */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
}dce_attach_data,								/* ATTACH */
 dce_detach_data,								/* DETACH */
 dce_stop_monitor_data;							/* STOP MONITOR */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
	ra_uint_t   ip;
	ra_uint_t   port;
}dce_start_monitor_remote_data;					/* START_MONITOR_REMOTE */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
	ra_string_t file;
}dce_start_monitor_local_data;					/* START_MONITOR_LOCAL */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
	ra_string_t type;
	ra_string_t name;
	ra_string_t value;
}dce_set_nv_pair_data;							/* SET_NV_PAIR */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
	ra_uint_t   severity;
	ra_string_t messageId;
	ra_string_t message;
}dce_error_string_data;							/* ERROR_STRING */

struct {
	ra_uint64_t processId;
	ra_string_t processUUID;
	ra_string_t agent;
	ra_string_t agentUUID;
	ra_string_t agentType;
}dce_agent_active_data,							/* AGENT_ACTIVE */
 dce_agent_inactive_data,						/* AGENT_INACTIVE */
 dce_agent_details_data;							/* AGENT_DETAILS */

struct {
	ra_uint64_t processId;
/* BEGIN:  235649 */
#if defined _LINUX_X86  || defined _LINUX_390
	ra_uint64_t messageProcessId;
#endif
/* END: 235649 */
	ra_string_t processUUID;
	ra_string_t agent;
	ra_string_t agentUUID;
	ra_string_t agentType;
	ra_string_t nodeUUID;
}dce_agent_scoping_information_data;				/* AGENT_SCOPING_INFORMATION */

struct {
	ra_uint64_t processId;
	ra_string_t processUUID;
	ra_string_t agent;
	ra_string_t agentUUID;
	ra_string_t agentType;
	ra_string_t nodeUUID;
	ra_array_t  configuration;
}dce_agent_configuration_data;					/* AGENT_CONFIGURATION */

struct {
	ra_uint64_t processId;
	ra_string_t agent;
	ra_string_t node;
	ra_uint64_t peerProcessId;
	ra_string_t peerAgent;
	ra_string_t peerNode;
}dce_agent_request_monitor_data, 				/* AGENT_REQUEST_ATTACH */
 dce_controller_request_monitor_data,			/* CONTROLLER_REQUEST_MONITOR */
 dce_peer_unreachable_data;						/* PEER_UNREACHABLE */

/* For the following commands, I am imagining that the DCE will have access 
   to a table of metadata about the installed agents that looks something
   like this:

    Agents/
        com.mycompany.myproduct.Agent1/
            Interfaces/
                org.eclipse.hyades.dce.agent
                com.mycompany.myproduct.custominterface1
                com.mycompany.myproduct.custominterface2
            LaunchInfo/
                Path/
                    <path to my agent>
                Process/
                    <process to launch>
                Parameters/
                    <parameters for invokation>
            AgentDetails/
                Singleton/
                    false
        com.mycompany.myproduct.Agent2/
            Interfaces/
                org.eclipse.hyades.dce.agent
                com.mycompany.myproduct.custominterface1
            LaunchInfo/ ...
            AgentDetails/ ...
        com.mycompany.myproduct.Agent3/
            Interfaces/
                org.eclipse.hyades.dce.agent
                com.mycompany.myproduct.custominterface2
            LaunchInfo/ ...
            AgentDetails/ ...
    Interfaces/
        org.eclipse.hyades.dce.agent/
            com.mycompany.myproduct.Agent1
            com.mycompany.myproduct.Agent2
            com.mycompany.myproduct.Agent3
        com.mycompany.myproduct.custominterface1/
            com.mycompany.myproduct.Agent1
            com.mycompany.myproduct.Agent2
        com.mycompany.myproduct.custominterface1/
            com.mycompany.myproduct.Agent1
            com.mycompany.myproduct.Agent3
*/


/* If an interfaceId is specified (optional), only agents which advertise that
      interface will be returned.  Otherwise, all available agents.           */
struct {
    ra_string_t interfaceId;
}dce_query_available_agents_data;				/* QUERY_AVAILABLE_AGENTS */

struct {
	ra_array_t agents;
}dce_available_agents_data;     				/* AVAILABLE_AGENTS */

/* Here, the agent name is required.  Without creating the agent, the DCE will
   return a list of interfaces advertised by the agent.                       */
struct {
    ra_string_t agent;
}dce_query_agent_interfaces_data;				/* QUERY_AGENT_INTERFACES */

struct {
	ra_array_t interfaces;
}dce_agents_interfaces_data;     				/* AGENT_INTERFACES */

struct {
	ra_array_t interfaces;
}dce_agents_interfaces_data;     				/* AGENT_INTERFACES */

LAUNCH_AGENT

/* The structure of a COMMAND using the new protocol */
typedef struct {
    ra_uint_t   headerId;    /* identifies the format of the header                     */
    ra_uint_t   target;      /* the identifier of the component to receive this command */
    ra_string_t targetHost;  /* UUID of the DCE to which the target is attached         */
    ra_uint_t   source;      /* identifies the sender of the command                    */
    ra_string_t sourceHost;  /* UUID of the DCE to which the source is attached         */
    ra_string_t interfaceId; /* tells the target component what the command ID means    */
    ra_uint_t   commandId;   /* identifies the command to be invoked                    */
    ra_uint_t   context;     /* used to correlate commands with their responses         */
    ra_string_t data;        /* command-specific data                                   */
} ra_command2_t;

typedef struct _command_entry_node2 {
	ra_command2_t *command;
	struct _command_entry_node2 *next;
	struct _command_entry_node2 *previous;
}ra_command_list_node2_t;

typedef struct {
	ra_command_list_node2_t *head;
	ra_command_list_node2_t *tail;
	ra_uint_t count;
}ra_command_list2_t;

typedef struct {
	ra_uint_t type;
	ra_uint_t ticket;
	ra_uint_t length;
	ra_string_t key;
	ra_command_list2_t commands;
}ra_message2_t;

/* The COMMAND ID's for the org.eclipse.hyades.dce interface */
#define CID_AUTHENTICATE						0x00000001
#define CID_LAUNCH_PROCESS						0x00000010
#define CID_KILL_PROCESS						0x0000001B
#define CID_QUERY_PROCESS_LIST					0x00000011
#define CID_QUERY_REGISTERED_AGENT_LIST 		0x00000012
#define CID_QUERY_AGENT_DETAILS					0x0000001C
#define CID_REGISTER_AGENT_NOTIFICATION			0x00000013
#define CID_ATTACH_TO_AGENT						0x00000014
#define CID_DETACH_FROM_AGENT					0x00000015
#define CID_START_MONITORING_AGENT_REMOTE		0x00000016
#define CID_START_MONITORING_AGENT_LOCAL		0x00000017
#define CID_STOP_MONITORING_AGENT				0x00000018
#define CID_SET_NAME_VALUE_PAIR					0x00000019
#define CID_QUERY_AVAILABLE_AGENTS              0x0000001D
#define CID_QUERY_AGENT_INTERFACES              0x0000001E
#define CID_LAUNCH_AGENT                        0x0000001F

